/* eslint-disable @typescript-eslint/no-explicit-any */ import * as React from 'react';
import { ResponsiveContainer } from './ResponsiveContainer';
/**
 * An HOC to update wrapped component on container resize.
 * {@docCategory ResponsiveContainer}
 */ export function withResponsiveContainer(WrappedComponent) {
    const ComponentWithResponsiveContainer = ({ aspect, width, height, minWidth, minHeight, maxHeight, onResize, ...restProps })=>{
        return /*#__PURE__*/ React.createElement(ResponsiveContainer, {
            aspect: aspect,
            width: width,
            height: height,
            minWidth: minWidth,
            minHeight: minHeight,
            maxHeight: maxHeight,
            onResize: onResize
        }, /*#__PURE__*/ React.createElement(WrappedComponent, restProps));
    };
    return ComponentWithResponsiveContainer;
}
